HDU 1595 find the longest of the shortest

来源:互联网 发布:手机5g网络怎么设置 编辑:程序博客网 时间:2024/04/30 10:42

find the longest of the shortest

Time Limit: 1000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1924    Accepted Submission(s): 675


Problem Description
Marica is very angry with Mirko because he found a new girlfriend and she seeks revenge.Since she doesn't live in the same city, she started preparing for the long journey.We know for every road how many minutes it takes to come from one city to another.
Mirko overheard in the car that one of the roads is under repairs, and that it is blocked, but didn't konw exactly which road. It is possible to come from Marica's city to Mirko's no matter which road is closed.
Marica will travel only by non-blocked roads, and she will travel by shortest route. Mirko wants to know how long will it take for her to get to his city in the worst case, so that he could make sure that his girlfriend is out of town for long enough.Write a program that helps Mirko in finding out what is the longest time in minutes it could take for Marica to come by shortest route by non-blocked roads to his city.
 

Input
Each case there are two numbers in the first row, N and M, separated by a single space, the number of towns,and the number of roads between the towns. 1 ≤ N ≤ 1000, 1 ≤ M ≤ N*(N-1)/2. The cities are markedwith numbers from 1 to N, Mirko is located in city 1, and Marica in city N.
In the next M lines are three numbers A, B and V, separated by commas. 1 ≤ A,B ≤ N, 1 ≤ V ≤ 1000.Those numbers mean that there is a two-way road between cities A and B, and that it is crossable in V minutes.
 

Output
In the first line of the output file write the maximum time in minutes, it could take Marica to come to Mirko.
 

Sample Input
5 61 2 41 3 32 3 12 4 42 5 74 5 16 71 2 12 3 43 4 44 6 41 5 52 5 25 6 55 71 2 81 4 102 3 92 4 102 5 13 4 73 5 10
 

Sample Output
111327

题意:由于男盆友不想见到前女友,但是前女友又能找到最短路,所以男盆友(不对,前男友)希望最短路中某两城市间的路不能相连。

思路:所以,前男友需要先找到最短路,然后再枚举破坏最短路中的每条路,进而最出最长路。只用在dijkstra的基础上添加一个fa[N]记录父亲结点的数组就可以了。


#include <iostream>#include <stdio.h>#include <string>#include <cstring>#include <algorithm>#define N 1009#define INF 0x3f3f3fusing namespace std;int n,m;int u,v,w;int map[N][N];int vis[N];int dis[N];//表示当前结点到任一点的距离,即添加边的过程int fa[N];void dijkstra(int x){    memset(dis,INF,sizeof dis);    memset(vis,0,sizeof vis);    int now,mid;    dis[1]=0;    for(int i=1;i<=n;i++)    {        mid=INF;        for(int j=1;j<=n;j++)        {            if(!vis[j]&&mid>dis[j])            {                mid=dis[j];                now=j;            }        }        vis[now]=1;        for(int j=1;j<=n;j++)        {            if(dis[j]>dis[now]+map[now][j])            {                dis[j]=dis[now]+map[now][j];                if(x)                fa[j]=now;            }        }    }}int main(){    while(~scanf("%d%d",&n,&m))    {        for(int i=0;i<=n;i++)        for(int j=0;j<=n;j++)        {            if(i==j)            map[i][j]=0;            else            map[i][j]=INF;        }        memset(fa,0,sizeof fa);        for(int i=1;i<=m;i++)        {            scanf("%d%d%d",&u,&v,&w);            map[u][v]=map[v][u]=w;        }        dijkstra(1);        int i;        int ans=dis[n];        for(i=n;i!=1;i=fa[i])//在找到的最短路中,枚举阻断的路,求出最长路        {            int ff=map[i][fa[i]];            map[i][fa[i]]=INF;            map[fa[i]][i]=INF;            dijkstra(0);            if(ans<dis[n])             ans=dis[n];            map[i][fa[i]]=map[fa[i]][i]=ff;            //cout<<"__________"<<endl;           //cout<<dis[n]<<endl;        }        cout<<ans<<endl;    }    return 0;}








0 0